
function initDebug()
    db = regGetBool('tool.debugMode')
end

function dbw(str, value) if db then DebugWatch(str, value) end end
function dbp(str, newLine) if db then DebugPrint(str .. ternary(newLine, '\n', '')) print(str .. ternary(newLine, '\n', '')) end end
function dbl(p1, p2, c1, c2, c3, a) if db then DebugLine(p1, p2, c1, c2, c3, a) end end
function dbdd(pos,w,l,r,g,b,a,dt) DrawDot(pos,w,l,r,g,b,a,dt) end
function dds(transform, radius, sides, info)
    if db then
        local tr1 = TransformCopy(transform)
        radius = radius or 1
        sides = sides or 100
        visual.drawpolygon( tr1, radius, nil, sides, info, true)
        local tr2 = TransformCopy(transform)
        tr2.rot = QuatRotateQuat(tr2.rot, QuatEuler(0, 0, 90))
        visual.drawpolygon( tr2, radius, nil, sides, info, true)
        local tr3 = TransformCopy(transform)
        tr3.rot = QuatRotateQuat(tr3.rot, QuatEuler(90, 0, 0))
        visual.drawpolygon( tr3, radius, nil, sides, info, true)
    end
end

function debugMod()
    db = regGetBool('tool.debugMode')
    debugBodyControllers()
end

-- Custom debug messages management to avoid flooding the screen
maxDebugMessages = 10
lastDebugMessages = {}
lastDebugTimer = 6
function dbm(str) addDebugMessage(str) print(str) end
function addDebugMessage(str)
    lastDebugMessages[#lastDebugMessages+1] = str
    if #lastDebugMessages > maxDebugMessages then
        table.remove(lastDebugMessages, 1)
    end
    lastDebugTimer = 6
end

function debugBodyControllers()

    if lastDebugTimer > 0 then
        lastDebugTimer = lastDebugTimer - GetTimeStep()
    end
    -- local bcInfo = BodyController_info[1]
    -- dbw('BODY CONTROLLER #bodyControllersList', #bcInfo.bodyControllersList)

    -- if db then
    --     for i=1,#bcInfo.bodyControllersList do

    --     end
    -- end

end
